# Migrating existing Angular applications to SharePoint Framework sample

## Summary

This is a sample Angular application before and after it has been migrated to a SharePoint Framework client-side web part.

Application before migration:
![Angular todo application](./assets/angular-todo-preview.png)

Application after migration:
![Angular todo application as a SharePoint Framework client-side web part](./assets/angular-todo-spfx-preview.png)

## Applies to

* [SharePoint Framework Developer Preview](http://dev.office.com/sharepoint/docs/spfx/sharepoint-framework-overview)
* [Office 365 developer tenant](http://dev.office.com/sharepoint/docs/spfx/set-up-your-developer-tenant)

## Solution

Solution|Author(s)
--------|---------
angular-migration|Waldek Mastykarz (MVP, Rencore, @waldekm)

## Version history

Version|Date|Comments
-------|----|--------
1.0.0|October 21, 2016|Initial release

## Disclaimer
**THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.**

---

Follow the setup instructions:
- [Angular application](./angular-todo/README.md)
- [SharePoint Framework client-side web part](./angular-todo-webpart/README.md)

![](https://telemetry.sharepointpnp.com/sp-dev-fx-webparts/samples/angular-migration)