# Taxonomy Web Part

## Summary
Sample Web Part illustrating
* Reading taxonomy term stores' hierarchy from SharePoint
* Loading JavaScript Object Model scripts
* creating Knockout components

![Taxonomy Sample Web Part](./assets/Taxonomy.png)

## Used SharePoint Framework Version
![drop](https://img.shields.io/badge/drop-ga-green.svg)

## Applies to

* [SharePoint Framework Developer Preview](http://dev.office.com/sharepoint/docs/spfx/sharepoint-framework-overview)

## Solution

Solution|Author(s)
--------|---------
knockout-taxonomy | Alex Terentiev ([Sharepointalist Inc.](http://www.sharepointalist.com), [AJIXuMuK](https://github.com/AJIXuMuK))

## Version history

Version|Date|Comments
-------|----|--------
1.0|November 12, 2016|Initial release
1.1|May 5, 2017|Update to GA Release, fix of minor bug

## Disclaimer
**THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.**

---

## Minimal Path to Awesome

- Clone this repository
- in the command line run:
  - `npm i`
  - `gulp serve`

> Include any additional steps as needed.

## Features
This project contains Client-Side Web Part built on the SharePoint Framework illustrating how to request Taxonomy Term Stores' hierarchy from SharePoint.
This Web Part illustrates the following concepts on top of the SharePoint Framework:

- Reading taxonomy term stores' hierarchy from SharePoint
- Loading JavaScript Object Model scripts (init.js, sp.runtime.js, sp.js, taxonomy.js)
- creating custom Knockout components
- styling HTML elements to match Fabric UI experience

<img src="https://telemetry.sharepointpnp.com/sp-dev-fx-webparts/samples/knockout-taxonomy" />